/* dlist.h: */

/*
 * @(#) $Header: /cs/research/pp/hubris/pp-beta/Chans/dirlist/RCS/dlist.h,v 5.0 90/09/20 15:46:26 pp Exp Locker: pp $
 *
 * $Log:	dlist.h,v $
 * Revision 5.0  90/09/20  15:46:26  pp
 * rcsforce : 5.0 public release
 * 
 *
 */



#ifndef _H_DIRLIST_DLIST
#define _H_DIRLIST_DLIST

#define PP

#include	"or.h"

#ifdef ISODEUFN
#include	<isode/quipu/ufn.h>
#else
#include	"ufn.h"
#endif


typedef struct ORName {
	OR_ptr	on_or;
	DN	on_dn;
} ORName ;


#define NULLORName (ORName *) NULL



typedef struct dl_policy {
	char	dp_expand;

	int	dp_convert;
#define DP_ORIGINAL	1	/* default */
#define DP_FALSE	2
#define DP_TRUE		3	

	int	dp_priority;
/* #define DP_ORIGINAL	1 */
#define DP_LOW		2	/* default */
#define DP_NORMAL	3
#define DP_HIGH		4

} dl_policy;



typedef struct dl_permit {

	int 	dp_type;
#define DP_INDIVIDUAL	1
#define DP_MEMBER	2
#define DP_PATTERN	3
#define DP_GROUP	4

	union {
		ORName	* dp_un_or;
		DN	dp_un_dn;
	} dp_un;

#define dp_or dp_un.dp_un_or
#define dp_dn dp_un.dp_un_dn

} dl_permit;



#endif
