/* rfc2trace.c - Converts a RFC string into a Trace struct */

# ifndef lint
static char Rcsid[] = "@(#)$Header: /cs/research/pp/hubris/pp-beta/Lib/format/RCS/rfc2trace.c,v 5.0 90/09/20 16:05:55 pp Exp Locker: pp $";
# endif

/*
 * $Header: /cs/research/pp/hubris/pp-beta/Lib/format/RCS/rfc2trace.c,v 5.0 90/09/20 16:05:55 pp Exp Locker: pp $
 *
 * $Log:	rfc2trace.c,v $
 * Revision 5.0  90/09/20  16:05:55  pp
 * rcsforce : 5.0 public release
 * 
 */



#include "util.h"
#include "mta.h"




/* ---------------------  Begin  Routines  -------------------------------- */




int rfc2trace (tp, str)
Trace   *tp;
char    *str;
{
	char    *cp = str,
		*bp = str;


	PP_DBG (("Lib/rfc2trace (%s)", str));

	cp = index (str, ';');

	if (cp == NULLCP)
		return NOTOK;
	else
		*cp++ = '\0';

	if (*cp == ' ')
		cp++;

	if (rfc2globalid (&tp->trace_DomId, bp) == NOTOK)
		return NOTOK;

	if (rfc2domsinfo (&tp->trace_DomSinfo, cp) == NOTOK)
		return NOTOK;

	return OK;
}
