/* or_basic.c: basic low level or structure manipulation */

# ifndef lint
static char Rcsid[] = "@(#)$Header: /cs/research/pp/hubris/pp-beta/Lib/or/RCS/or_basic.c,v 5.0 90/09/20 16:07:48 pp Exp Locker: pp $";
# endif

/*
 * $Header: /cs/research/pp/hubris/pp-beta/Lib/or/RCS/or_basic.c,v 5.0 90/09/20 16:07:48 pp Exp Locker: pp $
 *
 * $Log:	or_basic.c,v $
 * Revision 5.0  90/09/20  16:07:48  pp
 * rcsforce : 5.0 public release
 * 
 */



#include "or.h"
#include "util.h"

			
OR_ptr or_new (type, ddname, value)
int             type;
char            *ddname;
char            *value;
{
    OR_ptr      or;

    PP_DBG (("or_util.c/or_new ('%d', '%s', '%s')",
		   type, ddname, value));

    or = (OR_ptr) smalloc (sizeof (struct or_part));
    if (or == NULLOR)
	return NULLOR;

    or -> or_type = type;
    or -> or_encoding = or_type2charset (type);
    or -> or_next = NULLOR;
    or -> or_prev = NULLOR;

    if (type != OR_DD ) {
	or -> or_ddname = NULLCP;
	or -> or_value = strdup (value);
    }
    else {
	or -> or_ddname = strdup (ddname);
	or -> or_value = strdup (value);
    }
    return (or);
}

OR_ptr or_dup (or)
OR_ptr or;
{
    return (or_new (or -> or_type, or -> or_ddname, or -> or_value));
}

OR_ptr or_tdup (or)
OR_ptr or;
{
    OR_ptr new = NULLOR;

    if (or == NULLOR)
	return NULLOR;
    new = or_dup (or);
    new -> or_next = or_tdup (or -> or_next);
    if (new -> or_next)
	new -> or_next -> or_prev = new;
    return new;
}

void or_free (tree)
OR_ptr  tree;
{
	if (tree == NULLOR)
		return;

	if (tree -> or_next)
		or_free (tree -> or_next);
	if (tree -> or_value)
		free (tree -> or_value);
	if (tree -> or_ddname)
		free (tree -> or_ddname);
	free ((char *)tree);
}
