/* timeout.c: provide a timeout function */

# ifndef lint
static char Rcsid[] = "@(#)$Header: /cs/research/pp/hubris/pp-beta/Lib/util/RCS/timeout.c,v 5.0 90/09/20 16:18:05 pp Exp Locker: pp $";
# endif

/*
 * $Header: /cs/research/pp/hubris/pp-beta/Lib/util/RCS/timeout.c,v 5.0 90/09/20 16:18:05 pp Exp Locker: pp $
 *
 * $Log:	timeout.c,v $
 * Revision 5.0  90/09/20  16:18:05  pp
 * rcsforce : 5.0 public release
 * 
 */



#include <signal.h>
#include "util.h"



/* __________________________________________________________________________


provide a timeout function for jobs that could potentially hang
Only one entry is given - timeout(value)
timeout(value) will be longjumped back to

____________________________________________________________________________*/




jmp_buf _timeobuf;
static SFP      oldalrm;


SFD _tcatch()
{
	longjmp(_timeobuf,1);
}


void _timeout(val)
unsigned val;
{
	if(val)
		oldalrm = signal (SIGALRM, _tcatch);
	alarm(val);
	if (!val)
		signal (SIGALRM, oldalrm);
}
