/* wr_q.c: write out a queue structure to a Control File in Q/ADDR */

# ifndef lint
static char Rcsid[] = "@(#)$Header: /cs/research/pp/hubris/pp-beta/Lib/io/RCS/wr_q.c,v 5.0 90/09/20 16:07:16 pp Exp Locker: pp $";
# endif

/*
 * $Header: /cs/research/pp/hubris/pp-beta/Lib/io/RCS/wr_q.c,v 5.0 90/09/20 16:07:16 pp Exp Locker: pp $
 *
 * $Log:	wr_q.c,v $
 * Revision 5.0  90/09/20  16:07:16  pp
 * rcsforce : 5.0 public release
 * 
 */



/* __________________________________________________________________________

This routine is used so that there is only one entry point to q2txt()
which is located in Lib/pp/tx_q.c

____________________________________________________________________________*/



#include "head.h"
#include "q.h"




/* ---------------------  Begin  Routines  -------------------------------- */



int wr_q (qp, fp)
register Q_struct       *qp;
FILE                    *fp;
{
	int             retval;

	PP_DBG (("Lib/wr_q (type=%d, size=%d)", qp->msgtype, qp->msgsize));

	retval = q2txt (fp, qp);
	if (retval == NOTOK)
		return (RP_FIO);
	return (RP_OK);
}
